#ifndef _ENTRY_CPP
#define _ENTRY_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "NSWFL.H"
#include "Entry.H"
#include "Package.H"
#include "Init.H"
#include "CCmdLine.H"
#include "Console.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/OpenPassDlg.H"
#include "../Dialogs/NewPassDlg.H"
#include "../Dialogs/ReadingDlg.H"
#include "../Dialogs/ExtractDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HINSTANCE ghAppInstance = NULL;

char gsAppCopyRight[64];
char gsFileVersion[32];
char gsTitleCaption[64];
char gsRegistryKey[1024];
char gsWorkingOutput[MAX_PATH + 1];
char gsLastExtractLocation[MAX_PATH + 1];
char gsArchiveName[MAX_PATH + 1];
char gsPassword[1024 + 1];

DWORD gdwCurrentJobType = 0;

bool gbAutoClose = false;
bool gbArchiveOpen = false;

int giPkgAttribs = ATTRIB_DATETIME | ATTRIB_CRCCHECK | ATTRIB_SAVEPATHS | ATTRIB_ATTRIBUTES | ATTRIB_COMPRESSION;

short giCompressLevel = 0;
short giCryptAlgo = 0;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ParseCmdLine(CCmdLine *lpCmd);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevious, LPSTR CmdLine, int CmdShow)
{
	CCmdLine MyCmd;

	ghAppInstance = hInstance;

	//MsgBox(CmdLine);

	if(!InitializeApp())
    {
        return 1;
    }

	if(MyCmd.Init())
	{
		ParseCmdLine(&MyCmd);

		DWORD ExitCode;
		while(GetExitCodeThread(hWorker_Thread_Handle, &ExitCode))
		{
			if(ExitCode != STILL_ACTIVE)
			{
				break;
			}
			else Sleep(100);
		}

	}

	MyCmd.Destroy();
	
	if(!UninitializeApp())
    {
        return 1;
    }

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ParseCmdLine(CCmdLine *lpCmd)
{
	int iArg = 0;
	int iArgSz = 0;
	char *sArg = NULL;
	char *sMsg = NULL;

	char sSource[MAX_PATH];

	bool bEncrypt = false;
	bool bDecrypt = false;
	bool bAuto = false;
	bool bSilent = false;
	bool bView = false;

	if(lpCmd->iArgCount == 1)
	{
	    // Create new archive
		DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
		return 0;
	}

	while(iArg < lpCmd->iArgCount)
	{
		sArg = "/New";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
	        // Create new archive
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
			return 0;
		}

		sArg = "/Source:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], sSource);
			strcpy(gsArchiveName, sSource);
			//MsgBox(gsArchiveName);
		}

		sArg = "/Target:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsWorkingOutput);
			strcpy(gsExtractLocation, gsWorkingOutput);
			//MsgBox(gsWorkingOutput);
		}

		sArg = "/Encrypt";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			bEncrypt = true;
		}

		sArg = "/Decrypt";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			bDecrypt = true;
		}

		sArg = "/View";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			bView = true;
		}

		sArg = "/Silent";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			bSilent = true;
		}

		sArg = "/Password";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsPassword);
		}

		sArg = "/AutoClose";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			gbAutoClose = true;
		}

		iArg++;
	}

	/*
	if(gbAutoClose || bAuto)
	{
		if(strlen(gsPassword) == 0 || strlen(sSource) == 0 || strlen(gsWorkingOutput) == 0)
		{
			sMsg = "If either the \"/AutoClose\" or \"/Auto\" parameters are specified you must also specifiy:\r\n"
				"\tSource: (by using the \"/Source:\" parameter)\r\n"
				"\tTarget: (by using the \"/Target:\" parameter)\r\n"
				"\tPassword: (by using the \"/Password:\" parameter)\r\n\r\n"
				"Example:\r\n\tProjEps.exe /Source:\"C:\\My Folder\" /Target:\"C:\\NewFile.pce\" /Auto /AutoClose";
			MessageBox(NULL, sMsg, gsTitleCaption, NULL);
			return 1;
		}

	}
*/
	if((bDecrypt == false && bEncrypt == false) || bView == true)
	{
        // View an existing archive
        gdwCurrentJobType = JOB_TYPE_READING;
        if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), NULL, OpenPassDialog) != 1)
        {
            return 0;
        }
        hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) sSource, CREATE_SUSPENDED, &dwWorker_Thread_ID);
        DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);

		return 0;
	}

	if(bDecrypt == true)
    {
        // Decrypt the entire archive.
		gdwCurrentJobType = JOB_TYPE_EXTRACTALL;
        if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), NULL, OpenPassDialog) != 1)
        {
            return 0;
        }
        //hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) sSource, CREATE_SUSPENDED, &dwWorker_Thread_ID);
        DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);

		return 0;
    }
    
    if(bEncrypt == true)
	{
		if(IsDirectory(sSource))
		{
			// Create a new archive from the directorys contents.

			gdwCurrentJobType = JOB_TYPE_PACKING_DIR;
			if(bAuto == false)
			{
				if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_NEWPASS), NULL, NewPassDialog) != 1)
				{
					return 0;
				}
			}
			hWorker_Thread_Handle = CreateThread(NULL, 0, CreateNewDirArchive_Worker_Thread, (LPVOID) sSource, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
		}
		else{
			// Create a new archive containing a single file.
			FilePack MyFilePack;

			MyFilePack.Initialize(&AltFilePackage);
			
			//This is alot of wasted memory, but we need it all.
			char FileName[MAX_PATH]; 
			char DirTemp[MAX_PATH]; //Just some memory for AddFile() ro use.
			char Root[MAX_PATH + 1];
			char Drive[MAX_PATH + 1];
			char Dir[MAX_PATH + 1];
			char File[MAX_PATH + 1];
			char Ext[MAX_PATH + 1];

			int RootLen = 0;

			_splitpath(sSource, Drive, Dir, File, Ext);
			_makepath(Root, Drive, Dir, NULL, NULL);
			_makepath(FileName, NULL, NULL, File, Ext);

			RootLen = strlen(Root);

			MyFilePack.AddFile(Root, RootLen, DirTemp, RootLen, FileName, &AltFilePackage);

			gdwCurrentJobType = JOB_TYPE_PACKING_FIL;
			if(bAuto == false)
			{
				if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_NEWPASS), NULL, NewPassDialog) != 1)
				{
					return 0;
				}
			}
			hWorker_Thread_Handle = CreateThread(NULL, 0, CreateFileArchive_Worker_Thread, (LPVOID) Root, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
		}

		return 0;
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

